/*
 * Batterieladezustand messen und anzeigen mit RGB LED 
 * (C) 2021 Softwareentwicklung-als-prozess.de
 */

// Die LED's
#define LEDRED   9
#define LEDGREEN 10
#define LEDBLUE  11

// Die Entladekurve
//a 1213 mV : 4,9 mV = 247,6 => 248
//b 1150 mV : 4,9 mV = 234,7 => 235
//c 1025 mV : 4,9 mV = 209,2 => 209
//d  700 mV : 4,9 mV = 142,9 => 143
#define ONE 248
#define TWO 235
#define THREE 209
#define FOUR 143

int batval = (int)0;

void setup() 
{
  pinMode(LEDRED  , OUTPUT);
  pinMode(LEDGREEN, OUTPUT);
  pinMode(LEDBLUE , OUTPUT);

  digitalWrite(LEDRED  , HIGH);
  digitalWrite(LEDGREEN, HIGH);
  digitalWrite(LEDBLUE , HIGH);
  delay(1000);
  digitalWrite(LEDRED  , LOW);
  digitalWrite(LEDGREEN, LOW);
  digitalWrite(LEDBLUE , LOW);

  digitalWrite(LEDBLUE, HIGH);
  delay(1000);
  digitalWrite(LEDBLUE, LOW);

  digitalWrite(LEDGREEN, HIGH);
  delay(1000);
  digitalWrite(LEDGREEN, LOW);

  digitalWrite(LEDRED, HIGH);
  delay(1000);
  digitalWrite(LEDRED, LOW);
}

void loop() 
{
  batval = analogRead(A0);
  if (batval > ONE) // Batterie ist voll
  {
    digitalWrite(LEDRED  , HIGH);
    digitalWrite(LEDGREEN, HIGH);
    digitalWrite(LEDBLUE , HIGH);
  }
  if ((batval <= ONE) && (batval > TWO))
  {
    digitalWrite(LEDRED  , LOW);
    digitalWrite(LEDGREEN, LOW);
    digitalWrite(LEDBLUE , HIGH);
  }
  if ((batval <= TWO) && (batval > THREE))
  {
    digitalWrite(LEDRED  , LOW);
    digitalWrite(LEDGREEN, HIGH);
    digitalWrite(LEDBLUE , LOW);    
  }
  if((batval <= THREE) && (batval > FOUR))
  {
    digitalWrite(LEDRED  , HIGH);
    digitalWrite(LEDGREEN, LOW);
    digitalWrite(LEDBLUE , LOW);        
  }
  if (batval <= FOUR)
  {
    digitalWrite(LEDRED  , LOW);
    digitalWrite(LEDGREEN, LOW);
    digitalWrite(LEDBLUE , LOW);    
  }
}
